%include "../sc.inc"

bits 32

global _DllMain@12

section .bss
	oldProtect: resd 1
	mpq: resd 1
	scen: resd 1
	size: resd 1
	buf: resd 1
	read: resd 1
	unitUID: resd 1
	unitPID: resd 1
	bufStrUnitUID: resb 256
	bufStrUnitPID: resb 256

section .rdata
	str_UnitUID: db '[UNIT] Unit ID: %d instances',0
	str_UnitPID: db '[UNIT] Player ID: %d instances',0
	str_scenariochk: db 'staredit\scenario.chk',0
	str_fanfare: db 'MapCheck r0 developed by Cinolt (2014-08-08)',0

section .text
	_DllMain@12:
		push ebp
		mov ebp, esp

		; patch to call our code
		mov eax, [ esp+12 ]
		cmp eax, 1 ; DLL_PROCESS_ATTACH
		jnz DllMain_end

		push dword oldProtect
		push dword 0x00000040 ; PAGE_EXECUTE_READWRITE
		push dword 10
		push dword 0x004860C4
		call dword [ VirtualProtect ]

		mov byte [ 0x004860C4 ], 0xBA
		mov dword [ 0x004860C4 + 1 ], check      ; mov edx, check
		mov dword [ 0x004860C4 + 5 ], 0x9090E2FF ; jmp edx
		mov byte [ 0x004860C4 + 9 ], 0x90

		push dword oldProtect
		push dword [ oldProtect ]
		push dword 10
		push dword 0x004860C4
		call dword [ VirtualProtect ]

		DllMain_end:
		leave
		mov eax, 1
		retn 12

	check:
		push ebp
		mov ebp, esp
		push esi
		push edi

		mov edx, [ 0x0051268C ] ; current ID?
		cmp ecx, edx
		jnz end

		cmp eax, 100
		jnz end

		push dword mpq
		push dword 0x00000000
		push dword 0x00000000
		push dword CurrentMapName
		call dword [ SFileOpenArchive ] ; open current map

		push dword scen
		push dword 0x00000000
		push dword str_scenariochk
		push dword [ mpq ]
		call dword [ SFileOpenFileEx ] ; open scenario.chk

		push dword 0x00000000
		push dword [ scen ]
		call dword [ SFileGetFileSize ] ; get scenario.chk size
		mov dword [ size ], eax

		push dword 0x00000004 ; PAGE_READWRITE
		push dword 0x00003000 ; MEM_COMMIT | MEM_RESERVE
		push dword [ size ]
		push dword 0x00000000
		call dword [ VirtualAlloc ]
		mov dword [ buf ], eax

		push dword 0x00000000
		push dword read
		push dword [ size ]
		push dword [ buf ]
		push dword [ scen ]
		call dword [ SFileReadFile ] ; read scenario.chk

		push dword [ scen ]
		call dword [ SFileCloseFile ] ; close scenario.chk

		push dword [ mpq ]
		call dword [ SFileCloseArchive ] ; close current map

		mov eax, str_fanfare
		call print

		xor eax, eax
		mov dword [ unitUID ], eax
		mov dword [ unitPID ], eax

		mov esi, [ buf ]
		chk_loop:
			cmp dword [ esi ], 0x54494e55 ; UNIT
			jnz chk_end

			push esi
				add esi, 4
				mov edi, [ esi ]
				add esi, 4
				unitLoop:
					test edi, edi
					jz unitLoopDone

					add esi, 8
					mov ax, [ esi ] ; UID
					cmp ax, 228
					jb unitLoop0
						inc dword [ unitUID ]
					unitLoop0:
					add esi, 8
					mov al, [ esi ] ; PID
					cmp al, 12
					jb unitLoop1
						inc dword [ unitPID ]
					unitLoop1:
					add esi, 20
					sub edi, 36

					jmp unitLoop
				unitLoopDone:
			pop esi

			chk_end:
				add esi, 4
				mov edi, [ esi ]
				sub dword [ size ], 8
				sub dword [ size ], edi
				jle chk_done ; gotta test this
				add esi, 4
				add esi, edi
				jmp chk_loop
		chk_done:

		push dword 0x00008000 ; MEM_RELEASE
		push dword 0x00000000
		push dword [ buf ]
		call dword [ VirtualFree ]

		mov eax, [ unitUID ]
		test eax, eax
		jz label0
			push dword [ unitUID ]
			push dword str_UnitUID
			push dword bufStrUnitUID
			call dword [ swsprintfA ]
			add esp, 12
			mov eax, bufStrUnitUID
			call print
		label0:
		mov eax, [ unitPID ]
		test eax, eax
		jz end
			push dword [ unitPID ]
			push dword str_UnitPID
			push dword bufStrUnitPID
			call dword [ swsprintfA ]
			add esp, 12
			mov eax, bufStrUnitPID
			call print
		end:
		pop edi
		pop esi
		leave

		mov eax, 0x00450210 ; resume from where we patched
		call eax
		mov eax, 0x00486476
		jmp eax

	print: ; eax must be set to a string pointer
		mov ecx, 0x005999EC
		mov ecx, [ecx]
		push 0x14
		mov edx, 0x0041B760
		call edx
		retn
